<?php
include('lib/my_error_manager.php');
include('lib/my_page_manager.php');
include('mysql_connect.php');

$manager=new my_page_manager();

$variables=$manager->fetch_variables(array("id_movie","deleted","error_genre","error_genre_delete"));

// movie name
$query=sprintf("SELECT M.title FROM movies M WHERE M.id_movie=%d",$manager->variables["id_movie"]);
$result=$mysqli->query($query);
$row=$result->fetch_row();
$page_title=$row[0];

// genres list
// I have
$query=sprintf('SELECT G.id_genre,G.genre FROM genres G, movies_genres MG WHERE G.id_genre=MG.id_genre AND MG.id_movie=%d ORDER BY G.genre',$manager->variables["id_movie"]);
$result=$mysqli->query($query);
$genres_have=array();
$id_genres_have=array();
while($row=$result->fetch_row())
{
   $id_genres_have[]=$row[0];
   $genres_have[]=$row[1];
}

// I do not have
$tmp_have=implode($id_genres_have, ', ');
if(empty($tmp_have))
{
   $query=sprintf('SELECT G.id_genre, G.genre FROM genres G ORDER BY G.genre',$manager->variables["id_movie"]);
}
else
{
   $query=sprintf('SELECT G.id_genre, G.genre FROM genres G WHERE G.id_genre NOT IN ('.$tmp_have.') ORDER BY G.genre',$manager->variables["id_movie"]);
}
$result=$mysqli->query($query);
$genres=array();
$id_genres=array();
while($row=$result->fetch_row())
{
   $id_genres[]=$row[0];
   $genres[]=$row[1];
}

$manager->open_page('Manage genres in '.$page_title);

// ADD GENRE
if(count($genres)>0)
{
   $manager->write('Add genre to '.$page_title,'bold');

   if($manager->variables["deleted"]=="error")
   {
      $manager->write("Generic error","red");
   }

   $form_a=$manager->form('add_genre_run.php');
   $form_a->open();
   $form_a->hidden_input('id_movie',$manager->variables['id_movie']);
   // genre
   $select_g=$form_a->construct_select_input();
   $select_g->name="id_genre";
   // error
   if(!empty($manager->variables["error_genre"]))
   {
      $form_a->add_error("id_genre","Select a genre");
   }
   $select_g->add_option('0','-select-');
   for($i=0;$i<count($genres);$i++)
   {
      $select_g->add_option($id_genres[$i],$genres[$i]);
   }
   $select_g->show_with_text('Genre: ');

   $form_a->submit_input("action","Add Genre");
   $form_a->close();
}

// DELETE GENRE
$manager->breakline();
if(count($genres_have)>0)
{
   $manager->write('Delete genre','bold');

   $form_b=$manager->form('add_genre_run.php');
   $form_b->open();
   $form_b->hidden_input('id_movie',$manager->variables['id_movie']);
   // genre
   $select_g=$form_b->construct_select_input();
   $select_g->name="id_genre";
   // error
   if(!empty($manager->variables["error_genre_delete"]))
   {
      $form_b->add_error("id_genre","Select a genre");
   }
   $select_g->add_option('0','-select-');
   for($i=0;$i<count($genres_have);$i++)
   {
      $select_g->add_option($id_genres_have[$i],$genres_have[$i]);
   }
   $select_g->show_with_text('Genre: ');

   $form_b->submit_input("action","Delete Genre");
   $form_b->close();
}

$manager->breakline();

// LINKS
$manager->return_link_with_get('info_movie.php',array("id_movie"=>$manager->variables["id_movie"]),'Back');
$manager->close_page();
?>
