<?php
include('lib/my_error_manager.php');
include('lib/my_page_manager.php');
include('mysql_connect.php');

$manager=new my_page_manager();

$manager->fetch_variables(array("type","id_movie","id_people","id_role","error_movie","error_people","error_role"));

$type=$manager->variables["type"];

if( $type=='movie'  )
{
   $query=sprintf("SELECT M.title FROM movies M WHERE M.id_movie=%d",$manager->variables["id_movie"]);
   $result=$mysqli->query($query);
   $row=$result->fetch_row();
   $page_title=$row[0];
}
else
{

   if( $type=='people'  )
   {
      $query=sprintf('SELECT CONCAT(P.name, " ", P.surname ) FROM people P WHERE P.id_people=%d',$manager->variables["id_people"]);
      $result=$mysqli->query($query);
      $row=$result->fetch_row();
      $page_title=$row[0];
   }
   else
   {
      $page_title='Something';
   }
}

$manager->open_page('Add to '.$page_title);

$manager->write('Add to '.$page_title,'bold');

$form_a=$manager->form("add_to_run.php");
$form_a->open();

// check errors
if(!empty($manager->variables["error_movie"]))
{
   $form_a->add_error("id_movie","Please insert movie");
}
if(!empty($manager->variables["error_people"]))
{
   $form_a->add_error("id_people","Please insert person");
}
if(!empty($manager->variables["error_role"]))
{
   $form_a->add_error("id_role","Please insert role");
}

// TYPE
$form_a->hidden_input("type",$type);

// SELECT MOVIE
if( $type=="movie" )
{
   $form_a->hidden_input("id_movie",$manager->variables["id_movie"]);
}
else
{
   $select_m=$form_a->construct_select_input();
   $select_m->name="id_movie";
   $query='SELECT M.id_movie, M.title FROM movies M ORDER BY M.title';
   $result=$mysqli->query($query);
   $select_m->add_option(0,"--select--");
   while($row=$result->fetch_row())
   {
      $select_m->add_option($row[0],$row[1]);
   }
   $select_m->show_with_text("Insert movie: ");
}

// SELECT PERSON
if( $type=="people"  )
{
   $form_a->hidden_input("id_people",$manager->variables["id_people"]);
}
else
{
   $select_p=$form_a->construct_select_input();
   $select_p->name="id_people";
   $query='SELECT P.id_people, CONCAT(P.surname, ", ", P.name) FROM people P ORDER BY P.surname';
   $result=$mysqli->query($query);
   $select_p->add_option(0,"--select--");
   while($row=$result->fetch_row())
   {
      $select_p->add_option($row[0],$row[1]);
   }
   $select_p->show_with_text('Insert person: ');
}

// SELECT ROLE
$select_r=$form_a->construct_select_input();
$select_r->name='id_role';
$query='SELECT R.id_role, R.role FROM roles R ORDER BY R.role';
$result=$mysqli->query($query);
$select_r->add_option(0,'--select--');
while($row=$result->fetch_row())
{
   $select_r->add_option($row[0],$row[1]);
}
$select_r->show_with_text('Insert role: ');

$form_a->submit_input("submit","Insert");

$form_a->close();

$manager->breakline();
if( $type=="movie" )
{
   $manager->return_link_with_get('info_movie.php',array('id_movie'=>$manager->variables["id_movie"]),'Return to movie');
}
else
{
   if( $type=="people" )
   {
      $manager->return_link_with_get('info_people.php',array('id_people'=>$manager->variables["id_people"]),'Return to person');
   }
   else
   {
      $manager->return_link('index.php','Home');
   }
}

$manager->close_page();
?>
