<?php
include('lib/my_error_manager.php');
include('lib/my_page_manager.php');
include('lib/my_log_manager.php');

$manager=new my_page_manager();
$log=new my_log_manager();

// READ THE INFO

// read the error_log.txt file
if(file_exists("log/error_log.txt"))
{
	$file=fopen("log/error_log.txt","r");
	$error_text="";
	while ( $line = fgets($file) )
	{
		$error_text=$error_text.$line.'<br>';
	}
	fclose($file);
	$error_log_filesize=round(filesize("log/error_log.txt")/1024,2);
}
else
{
	$error_text="No error log file found";
	$error_log_filesize=0;
}

// read the last 5 issued queries
$queries_text=$log->read_last_queries(5);
$action_log_filesize=round(filesize("log/action_log.txt")/1024,2); // NOTE: the file should exist because I created it in the log_manager __construct

// PRINT THE PAGE

$manager->open_page("Administration");

$status=$manager->fetch_variable("status");
if( $status == "error" )
{
	$manager->write('<a class="red">Generic error</a>',"HTML");
}

// error log
$manager->write("ERROR LOG","bold");
$manager->write($error_text,"HTML");
$manager->return_link_with_get('admin_run.php',array("action"=>"clear_error"),'[Clear error_log.txt]','( '.$error_log_filesize.' KB )');
if( $status == "cleared_error" )
{
	$manager->write('<a class="red">Cleared error_log.txt file</a>',"HTML");
}

$manager->breakline();

// action log
$manager->write("ACTION LOG","bold");
$manager->write("The last 5 queries:");
foreach($queries_text as $query_info)
{
	$manager->write($query_info,"HTML");
}
$manager->return_link_with_get('admin_run.php',array("action"=>"clear_action"),'[Clear action_log.txt]','( '.$action_log_filesize.' KB )');
if( $status == "cleared_action" )
{
	$manager->write('<a class="red">Cleared action_log.txt</a>',"HTML");
}

$manager->breakline();
$manager->return_link("index.php","Home");

// add a return link to the main page
$manager->close_page();

?>
