<?php
include('lib/my_error_manager.php');
include('lib/my_page_manager.php');
include('lib/my_log_manager.php');
include('mysql_connect.php');

$manager=new my_page_manager();

$variables=array("error_nation","error_role","error_genre","error_movie","error_people","successful","error_generic");
$manager->fetch_variables($variables);

$log=new my_log_manager();

// nations list
$query='SELECT id_nation, nation, language FROM nations ORDER BY nation';
$result=$mysqli->query($query);
$nations=array();
$id_nations=array();
while($row=$result->fetch_row())
{
   $id_nations[]=$row[0];
   $nations[]=$row[1].' ('.$row[2].')';
}

// roles list
$query='SELECT R.id_role, R.role FROM roles R ORDER BY R.role';
$result=$mysqli->query($query);
$roles=array();
$id_roles=array();
while($row=$result->fetch_row())
{
   $id_roles[]=$row[0];
   $roles[]=$row[1];
}

// genres list
$query='SELECT G.id_genre, G.genre FROM genres G ORDER BY G.genre';
$result=$mysqli->query($query);
$genres=array();
$id_genres=array();
while($row=$result->fetch_row())
{
   $id_genres[]=$row[0];
   $genres[]=$row[1];
}

// PAGE
$manager->open_page("Delete");

$manager->return_link('index.php','HOME');

if(!empty($manager->variables["successful"]))
{
   $manager->write('Deleted!','green');
}
if(!empty($manager->variables["error_generic"]))
{
   $manager->write('Error! Maybe you did not delete every reference to the entity you tried to delete','red');
}

// movies
$form_m=$manager->form('delete_run.php');
$form_m->open();
if(!empty($manager->variables["error_movie"]))
{
   $form_m->add_error('id_movie','Select movie');
}
$select_m=$form_m->construct_select_input();
$select_m->name="id_movie";
$query='SELECT M.id_movie, M.title FROM movies M ORDER BY M.title';
$result=$mysqli->query($query);
$select_m->add_option(0,"-select-");
while($row=$result->fetch_row())
{
   $select_m->add_option($row[0],$row[1]);
}
$select_m->show_with_text("Movie: ");
$form_m->submit_input("action","Delete Movie");
$form_m->close();

// people
$form_p=$manager->form('delete_run.php');
$form_p->open();
if(!empty($manager->variables["error_people"]))
{
   $form_p->add_error('id_people','Select person');
}
$select_p=$form_p->construct_select_input();
$select_p->name="id_people";
$query='SELECT P.id_people, CONCAT(P.surname, ", ", P.name) FROM people P ORDER BY P.surname';
$result=$mysqli->query($query);
$select_p->add_option(0,"-select-");
while($row=$result->fetch_row())
{
   $select_p->add_option($row[0],$row[1]);
}
$select_p->show_with_text('Person: ');
$form_p->submit_input("action","Delete Person");
$form_p->close();

// genres
$form_c=$manager->form('delete_run.php');
$form_c->open();
if(!empty($manager->variables["error_genre"]))
{
   $form_c->add_error('id_genre','Select genre');
}
$select_g=$form_c->construct_select_input();
$select_g->name="id_genre";
$select_g->add_option('0','-select-');
for($i=0;$i<count($genres);$i++)
{
   $select_g->add_option($id_genres[$i],$genres[$i]);
}
$select_g->show_with_text('Genre: ');
$form_c->submit_input("action","Delete Genre");
$form_c->close();

$manager->breakline();

// nations
$form_a=$manager->form('delete_run.php');
$form_a->open();
if(!empty($manager->variables["error_nation"]))
{
   $form_a->add_error('id_nation','Select nation');
}
$select_n=$form_a->construct_select_input();
$select_n->name="id_nation";
$select_n->add_option('0','-select-');
for($i=0;$i<count($nations);$i++)
{
   $select_n->add_option($id_nations[$i],$nations[$i]);
}
$select_n->show_with_text('Nation: ');
$form_a->submit_input("action","Delete Nation");
$form_a->close();

$manager->breakline();

// roles
$form_b=$manager->form('delete_run.php');
$form_b->open();
if(!empty($manager->variables["error_role"]))
{
   $form_b->add_error('id_role','Select role');
}
$select_r=$form_b->construct_select_input();
$select_r->name="id_role";
$select_r->add_option('0','-select-');
for($i=0;$i<count($roles);$i++)
{
   $select_r->add_option($id_roles[$i],$roles[$i]);
}
$select_r->show_with_text('Role: ');
$form_b->submit_input("action","Delete Role");
$form_b->close();

$manager->close_page();
?>
