<?php
include('lib/my_error_manager.php');
include('lib/my_page_manager.php');
include('lib/my_redirect.php');
include('lib/my_log_manager.php');
include('mysql_connect.php');

$manager=new my_page_manager();

$log=new my_log_manager();

$manager->fetch_variable("action");

switch($manager->variables["action"])
{
   case "Delete Movie": delete_movie($manager,$mysqli,$log);
                        break;
   case "Delete Person": delete_person($manager,$mysqli,$log);
                        break;
   case "Delete Role": delete_role($manager,$mysqli,$log);
                        break;
   case "Delete Genre": delete_genre($manager,$mysqli,$log);
                        break;
   case "Delete Nation": delete_nation($manager,$mysqli,$log);
                        break;
}

// DELETE MOVIE
function delete_movie($manager,$mysqli,$log)
{
   $manager->fetch_variables(array("id_movie"));

   $error_gen=false;

   if(empty($manager->variables["id_movie"]) || $manager->variables["id_movie"] == 0 )
   {
      $manager->variables["error_movie"]=1;
      $error_gen=true;
   }

   if($error_gen)
   {
      $link=my_redirect('delete.php');
      $link=$manager->compose_link($link,$manager->variables,true);
      $manager->redirect($link);
   }
   else
   {
      // delete smth
      $query=sprintf("DELETE FROM movies WHERE id_movie=%d ",$manager->variables["id_movie"]);

      $result=$mysqli->query($query);

      $log->add_entry('delete_run.php',$query);

      if(!$result)
      {
         $link=my_redirect('delete.php?error_generic=1');
         $manager->redirect($link);
      }
      else
      {
         $link=my_redirect('delete.php?successful=1');
         $manager->redirect($link);
      }
   }
}

// DELETE PERSON
function delete_person($manager,$mysqli,$log)
{
   $manager->fetch_variables(array("id_people"));

   $error_gen=false;

   if(empty($manager->variables["id_people"]) || $manager->variables["id_people"] == 0 )
   {
      $manager->variables["error_people"]=1;
      $error_gen=true;
   }

   if($error_gen)
   {
      $link=my_redirect('delete.php');
      $link=$manager->compose_link($link,$manager->variables,true);
      $manager->redirect($link);
   }
   else
   {
      // delete smth
      $query=sprintf("DELETE FROM people WHERE id_people=%d ",$manager->variables["id_people"]);

      $result=$mysqli->query($query);

      $log->add_entry('delete_run.php',$query);

      if(!$result)
      {
         $link=my_redirect('delete.php?error_generic=1');
         $manager->redirect($link);
      }
      else
      {
         $link=my_redirect('delete.php?successful=1');
         $manager->redirect($link);
      }
   }
}

// DELETE ROLE
function delete_role($manager,$mysqli,$log)
{
   $manager->fetch_variables(array("id_role"));

   $error_gen=false;

   if(empty($manager->variables["id_role"]) || $manager->variables["id_role"] == 0 )
   {
      $manager->variables["error_role"]=1;
      $error_gen=true;
   }

   if($error_gen)
   {
      $link=my_redirect('delete.php');
      $link=$manager->compose_link($link,$manager->variables,true);
      $manager->redirect($link);
   }
   else
   {
      // delete smth
      $query=sprintf("DELETE FROM roles WHERE id_role=%d ",$manager->variables["id_role"]);

      $result=$mysqli->query($query);

      $log->add_entry('delete_run.php',$query);

      if(!$result)
      {
         $link=my_redirect('delete.php?error_generic=1');
         $manager->redirect($link);
      }
      else
      {
         $link=my_redirect('delete.php?successful=1');
         $manager->redirect($link);
      }
   }
}

// DEL GENRE
function delete_genre($manager,$mysqli,$log)
{
   $manager->fetch_variables(array("id_genre"));

   $error_gen=false;

   if(empty($manager->variables["id_genre"]) || $manager->variables["id_genre"]==0 )
   {
      $manager->variables["error_genre"]=1;
      $error_gen=true;
   }

   if($error_gen)
   {
      $link=my_redirect('delete.php');
      $link=$manager->compose_link($link,$manager->variables,true);
      $manager->redirect($link);
   }
   else
   {
      // delete smth
      $query=sprintf("DELETE FROM genres WHERE id_genre=%d",$manager->variables["id_genre"]);

      $result=$mysqli->query($query);

      $log->add_entry('delete_run.php',$query);

      if(!$result)
      {
         $link=my_redirect('delete.php?error_generic=1');
         $manager->redirect($link);
      }
      else
      {
         $link=my_redirect('delete.php?successful=1');
         $manager->redirect($link);
      }
   }
}

// DEL NATION
function delete_nation($manager,$mysqli,$log)
{
   $manager->fetch_variable("id_nation");

   $error_gen=false;

   if(empty($manager->variables["id_nation"]) || $manager->variables["id_nation"]==0 )
   {
      $manager->variables["error_nation"]=1;
      $error_gen=true;
   }

   if($error_gen)
   {
      $link=my_redirect('delete.php');
      $link=$manager->compose_link($link,$manager->variables,true);
      $manager->redirect($link);
   }
   else
   {
      // del smth
      $query=sprintf('DELETE FROM nations WHERE id_nation=%d',$manager->variables["id_nation"]);

      $result=$mysqli->query($query);

      $log->add_entry('delete_run.php',$query);

      if(!$result)
      {
         $link=my_redirect('delete.php?error_generic=1');
         $manager->redirect($link);
      }
      else
      {
         $link=my_redirect('delete.php?successful=1');
         $manager->redirect($link);
      }
   }
}
?>
