<?php
include('lib/my_error_manager.php');
include('lib/my_page_manager.php');
include('lib/my_redirect.php');
include('lib/my_log_manager.php');
include('mysql_connect.php');

$manager=new my_page_manager();

$log=new my_log_manager();

$manager->fetch_variable("action");

switch($manager->variables["action"])
{
   case "Edit Movie": edit_movie($manager,$mysqli,$log);
                        break;
   case "Edit People": edit_person($manager,$mysqli,$log);
                        break;
}

// EDIT MOVIE
function edit_movie($manager,$mysqli,$log)
{
   $manager->fetch_variables(array("id_movie","title","id_nation","release_date","runtime","type"));

   $error_gen=false;

   /*
	if(get_magic_quotes_gpc())
	{
	   $manager->variables["title"]=stripslashes($manager->variables["title"]);
	   $manager->variables["type"]=stripslashes($manager->variables["type"]);
	}
   */

   if(empty($manager->variables["title"]))
   {
      $manager->variables["error_title"]=1;
      $error_gen=true;
   }

   if( ! (preg_match('/^[0-9]+$/',$manager->variables["id_nation"]) && $manager->variables["id_nation"] > 0) )
   {
      $manager->variables["error_nation"]=1;
      $error_gen=true;
   }

   if(empty($manager->variables["release_date"]) || ! preg_match('/^[0-9]{4}-[0-9]{2}-[0-9]{2}+$/',$manager->variables["release_date"]))
   {
      $manager->variables["error_release_date"]=1;
      $error_gen=true;
   }

   if( ! (preg_match('/^[0-9]+$/',$manager->variables["runtime"]) && $manager->variables["runtime"] > 0) )
   {
      $manager->variables["error_runtime"]=1;
      $error_gen=true;
   }

   if(empty($manager->variables["type"]))
   {
      $manager->variables["error_type"]=1;
      $error_gen=true;
   }

   if($error_gen)
   {
      $link=my_redirect('edit_movie.php');
      $link=$manager->compose_link($link,$manager->variables,true);
      $manager->redirect($link);
   }
   else
   {
      // add smth
      $title_sql=$mysqli->real_escape_string($manager->variables["title"]);
      $type_sql=$mysqli->real_escape_string($manager->variables["type"]);
      $query=sprintf("UPDATE movies SET title='%s', id_nation=%d, release_date='%s', runtime=%d, type='%s' WHERE id_movie=%d",$title_sql,$manager->variables["id_nation"],$manager->variables["release_date"],$manager->variables["runtime"],$type_sql,$manager->variables["id_movie"]);

      $result=$mysqli->query($query);

      $log->add_entry('edit_people_run.php',$query);

      if(!$result)
      {
         $link=my_redirect('edit_movie.php');
         $link=$manager->compose_link($link,array("error_generic"=>"1","id_movie"=>$manager->variables["id_movie"]),true);
         $manager->redirect($link);
      }
      else
      {
         $link=my_redirect('info_movie.php');
         $link=$manager->compose_link($link,array("successful"=>"1","id_movie"=>$manager->variables["id_movie"]),true);
         $manager->redirect($link);
      }
   }
}

// EDIT PERSON
function edit_person($manager,$mysqli,$log)
{
   $manager->fetch_variables(array("id_people","name","surname","id_nation","birthdate"));

   $error_gen=false;

   /*
	if(get_magic_quotes_gpc())
	{
	   $manager->variables["name"]=stripslashes($manager->variables["name"]);
	   $manager->variables["surname"]=stripslashes($manager->variables["surname"]);
	}
   */

   if(empty($manager->variables["name"]))
   {
      $manager->variables["error_name"]=1;
      $error_gen=true;
   }

   if(empty($manager->variables["id_people"]) || !preg_match('/^[0-9]+$/',$manager->variables["id_people"]))
   {
      $error_gen=true;
   }

   if(empty($manager->variables["surname"]))
   {
      $manager->variables["error_surname"]=1;
      $error_gen=true;
   }

   if( ! (preg_match('/^[0-9]+$/',$manager->variables["id_nation"]) && $manager->variables["id_nation"] > 0) )
   {
      $manager->variables["error_nation"]=1;
      $error_gen=true;
   }

   if(empty($manager->variables["birthdate"]) || ! preg_match('/^[0-9]{4}-[0-9]{2}-[0-9]{2}+$/',$manager->variables["birthdate"]))
   {
      $manager->variables["error_birthdate"]=1;
      $error_gen=true;
   }

   if($error_gen)
   {
      $link=my_redirect('edit_people.php');
      $link=$manager->compose_link($link,$manager->variables,true);
      $manager->redirect($link);
   }
   else
   {
      // edit smth
      $name_sql=$mysqli->real_escape_string($manager->variables["name"]);
      $surname_sql=$mysqli->real_escape_string($manager->variables["surname"]);
      $query=sprintf("UPDATE people SET name='%s' , surname='%s', id_nation=%d, birthdate='%s' WHERE id_people=%d",$name_sql,$surname_sql,$manager->variables["id_nation"],$manager->variables["birthdate"],$manager->variables["id_people"]);

      $result=$mysqli->query($query);

      $log->add_entry('edit_people_run.php',$query);

      if(!$result)
      {
         $link=my_redirect('edit_people.php');
         $link=$manager->compose_link($link,array("error_generic"=>"1","id_people"=>$manager->variables["id_people"]),true);
         $manager->redirect($link);
      }
      else
      {
         $link=my_redirect('info_people.php');
         $link=$manager->compose_link($link,array("successful"=>"1","id_people"=>$manager->variables["id_people"]),true);
         $manager->redirect($link);
      }
   }
}
?>
