<?php
include('lib/my_error_manager.php');
include('lib/my_page_manager.php');
include('mysql_connect.php');

$manager=new my_page_manager();

$variables=$manager->fetch_variables(array("id_movie","deleted"));

$query=sprintf("SELECT M.id_movie, M.title, M.release_date, N.language, M.runtime, M.type FROM movies M, nations N WHERE M.id_movie=%d AND M.id_nation=N.id_nation", $manager->variables["id_movie"]);

$result=$mysqli->query($query);

$row=$result->fetch_row();

$manager->open_page($row[1]);

if($manager->variables["deleted"]=="relation")
{
   $manager->write("Person deleted","red");
}
if($manager->variables["deleted"]=="error")
{
   $manager->write("Error! Maybe you tried to insert the same person in the same role twice","red");
}

$manager->write("General Info","bold");

my_echo('<p>');
my_echo('Title: '.$row[1]);
$manager->breakline();
my_echo('Release date: '.$row[2]);
$manager->breakline();
my_echo('Language: '.$row[3]);
$manager->breakline();
my_echo('Runtime: '.$row[4].' min');
$manager->breakline();
my_echo('Type: '.$row[5]);
my_echo('</p>');
// edit
$manager->return_link_with_get("edit_movie.php",array("id_movie"=>$manager->variables["id_movie"]),"Edit info");
$manager->breakline();
// find genres (if available)
$query=sprintf("SELECT GROUP_CONCAT(G.genre ORDER BY G.genre SEPARATOR ', ') FROM movies M, genres G, movies_genres MG WHERE M.id_movie=%d AND MG.id_movie=M.id_movie AND MG.id_genre=G.id_genre GROUP BY M.id_movie", $manager->variables["id_movie"]);
$result=$mysqli->query($query);
$row=$result->fetch_row();
if(empty($row[0]))
{
   $genres='empty';
}
else
{
   $genres=$row[0];
}
$manager->write('Genres: '.$genres,'HTML');
$manager->return_link_with_get('add_genre.php',array("id_movie"=>$manager->variables["id_movie"]),"Add/Delete Genre");
$manager->breakline();

// DIRECTORS
$query=sprintf("SELECT P.id_people , CONCAT( P.name, ' ', P.surname) , R.id_role FROM people P, roles R, movies_people MP WHERE MP.id_movie=%d AND MP.id_people=P.id_people AND MP.id_role=R.id_role AND R.role='director'",$manager->variables["id_movie"]);

$result=$mysqli->query($query);

$tot_producers=$result->num_rows;

if($tot_producers>0)
{
   $manager->write("Directors","bold");
   $table_p=$manager->table(2);
   $table_p->open();
   while($row=$result->fetch_row())
   {
     $actor_name='<a href="info_people.php?id_people='.$row[0].'">'.$row[1].'</a>';
     $link_delete='<a href="delete_movie_people.php?type=movie&amp;id_movie='.$manager->variables["id_movie"].'&amp;id_people='.$row[0].'&amp;id_role='.$row[2].'">X</a>';
     $table_p->add_row(array($actor_name,$link_delete));
   }
   $table_p->close();
}
$manager->breakline();

// PRODUCERS
$query=sprintf("SELECT P.id_people , CONCAT( P.name, ' ', P.surname), R.id_role FROM people P, roles R, movies_people MP WHERE MP.id_movie=%d AND MP.id_people=P.id_people AND MP.id_role=R.id_role AND R.role='producer'",$manager->variables["id_movie"]);

$result=$mysqli->query($query);

$tot_producers=$result->num_rows;

if($tot_producers>0)
{
   $manager->write("Producers","bold");
   $table_p=$manager->table(2);
   $table_p->open();
   while($row=$result->fetch_row())
   {
     $actor_name='<a href="info_people.php?id_people='.$row[0].'">'.$row[1].'</a>';
     $link_delete='<a href="delete_movie_people.php?type=movie&amp;id_movie='.$manager->variables["id_movie"].'&amp;id_people='.$row[0].'&amp;id_role='.$row[2].'">X</a>';
     $table_p->add_row(array($actor_name,$link_delete));
   }
   $table_p->close();
}
$manager->breakline();

// ACTORS
$query=sprintf("SELECT P.id_people, CONCAT(P.name, ' ', P.surname), R.role, R.id_role FROM people P, roles R, movies_people MP WHERE MP.id_movie=%d AND MP.id_people=P.id_people AND MP.id_role=R.id_role AND ( R.role='character (main)' OR R.role='character (supporting)') ORDER BY R.role",$manager->variables["id_movie"]);

$result=$mysqli->query($query);

$tot_actors=$result->num_rows;

if($tot_actors>0)
{
   $manager->write("Actors","bold");
   $table_a=$manager->table(3);
   $table_a->open();
   while($row=$result->fetch_row())
   {
      $actor_name='<a href="info_people.php?id_people='.$row[0].'">'.$row[1].'</a>';
      $role=$row[2];
      $link_delete='<a href="delete_movie_people?type=movie&amp;id_movie='.$manager->variables["id_movie"].'&amp;id_people='.$row[0].'&amp;id_role='.$row[3].'">X</a>';
      $table_a->add_row(array($actor_name,$role,$link_delete));
   }
   $table_a->close();
}

$manager->breakline();

// STAFF
$query=sprintf("SELECT P.id_people, CONCAT(P.name, ' ', P.surname), R.role, R.id_role FROM people P, roles R, movies_people MP WHERE MP.id_movie=%d AND MP.id_people=P.id_people AND MP.id_role=R.id_role AND NOT ( R.role='director' OR R.role='producer' OR R.role='character (main)' OR R.role='character (supporting)') ORDER BY R.role",$manager->variables["id_movie"]);

$result=$mysqli->query($query);

$tot_actors=$result->num_rows;

if($tot_actors>0)
{
   $manager->write("Others","bold");
   $table_a=$manager->table(3);
   $table_a->open();
   while($row=$result->fetch_row())
   {
      $actor_name='<a href="info_people.php?id_people='.$row[0].'">'.$row[1].'</a>';
      $role=$row[2];
      $link_delete='<a href="delete_movie_people?type=movie&id_movie='.$manager->variables["id_movie"].'&id_people='.$row[0].'&id_role='.$row[3].'">X</a>';
      $table_a->add_row(array($actor_name,$role,$link_delete));
   }
   $table_a->close();
}

$manager->breakline();
$manager->return_link_with_get("add_to.php",array("id_movie"=>$manager->variables["id_movie"],"type"=>'movie'),"Add a Person");
$manager->return_link_with_get("delete_movie.php",array("id_movie"=>$manager->variables["id_movie"]),"Delete Movie");
$manager->breakline();
$manager->return_link("index.php","Home");

$manager->close_page();
?>
