<?php
include('lib/my_error_manager.php');
include('lib/my_page_manager.php');
include('lib/my_redirect.php');
include('lib/my_log_manager.php');
include('mysql_connect.php');

$manager=new my_page_manager();

$log=new my_log_manager();

$manager->fetch_variable("action");

switch($manager->variables["action"])
{
   case "Add Movie": add_movie($manager,$mysqli,$log);
                        break;
   case "Add Person": add_person($manager,$mysqli,$log);
                        break;
   case "Add Role": add_role($manager,$mysqli,$log);
                        break;
   case "Add Genre": add_genre($manager,$mysqli,$log);
                        break;
   case "Add Nation": add_nation($manager,$mysqli,$log);
                        break;
}

// ADD MOVIE
function add_movie($manager,$mysqli,$log)
{
   $manager->fetch_variables(array("title","nation","release_date","runtime","type"));

   $error_gen=false;

   /*
	if(get_magic_quotes_gpc())
	{
	   $manager->variables["title"]=stripslashes($manager->variables["title"]);
	   $manager->variables["type"]=stripslashes($manager->variables["type"]);
	}
   */

   if(empty($manager->variables["title"]))
   {
      $manager->variables["error_title"]=1;
      $error_gen=true;
   }

   if( ! (preg_match('/^[0-9]+$/',$manager->variables["nation"]) && $manager->variables["nation"] > 0) )
   {
      $manager->variables["error_nation"]=1;
      $error_gen=true;
   }

   if(empty($manager->variables["release_date"]) || ! preg_match('/^[0-9]{4}-[0-9]{2}-[0-9]{2}+$/',$manager->variables["release_date"]))
   {
      $manager->variables["error_release_date"]=1;
      $error_gen=true;
   }

   if( ! (preg_match('/^[0-9]+$/',$manager->variables["runtime"]) && $manager->variables["runtime"] > 0) )
   {
      $manager->variables["error_runtime"]=1;
      $error_gen=true;
   }

   if(empty($manager->variables["type"]))
   {
      $manager->variables["error_type"]=1;
      $error_gen=true;
   }

   if($error_gen)
   {
      $link=my_redirect('insert.php');
      $link=$manager->compose_link($link,$manager->variables,true);
      $manager->redirect($link);
   }
   else
   {
      // add smth
      $title_sql=$mysqli->real_escape_string($manager->variables["title"]);
      $type_sql=$mysqli->real_escape_string($manager->variables["type"]);
      $query=sprintf("INSERT INTO movies(title,id_nation,release_date,runtime,type) VALUES ('%s',%d,'%s',%d,'%s')",$title_sql,$manager->variables["nation"],$manager->variables["release_date"],$manager->variables["runtime"],$type_sql);

      $result=$mysqli->query($query);

      $log->add_entry('insert_run.php',$query);

      if(!$result)
      {
         $link=my_redirect('insert.php?error_generic=1');
         $manager->redirect($link);
      }
      else
      {
         $link=my_redirect('insert.php?successful=1');
         $manager->redirect($link);
      }
   }
}

// ADD PERSON
function add_person($manager,$mysqli,$log)
{
   $manager->fetch_variables(array("name","surname","nationality","birthdate"));

   $error_gen=false;

   /*
	if(get_magic_quotes_gpc())
	{
	   $manager->variables["name"]=stripslashes($manager->variables["name"]);
	   $manager->variables["surname"]=stripslashes($manager->variables["surname"]);
	}
   */

   if(empty($manager->variables["name"]))
   {
      $manager->variables["error_name"]=1;
      $error_gen=true;
   }

   if(empty($manager->variables["surname"]))
   {
      $manager->variables["error_surname"]=1;
      $error_gen=true;
   }

   if( ! (preg_match('/^[0-9]+$/',$manager->variables["nationality"]) && $manager->variables["nationality"] > 0) )
   {
      $manager->variables["error_nationality"]=1;
      $error_gen=true;
   }

   if(empty($manager->variables["birthdate"]) || ! preg_match('/^[0-9]{4}-[0-9]{2}-[0-9]{2}+$/',$manager->variables["birthdate"]))
   {
      $manager->variables["error_birthdate"]=1;
      $error_gen=true;
   }

   if($error_gen)
   {
      $link=my_redirect('insert.php');
      $link=$manager->compose_link($link,$manager->variables,true);
      $manager->redirect($link);
   }
   else
   {
      // add smth
      $name_sql=$mysqli->real_escape_string($manager->variables["name"]);
      $surname_sql=$mysqli->real_escape_string($manager->variables["surname"]);
      $query=sprintf("INSERT INTO people(name,surname,id_nation,birthdate) VALUES ('%s','%s',%d,'%s')",$name_sql,$surname_sql,$manager->variables["nationality"],$manager->variables["birthdate"]);

      $result=$mysqli->query($query);

      $log->add_entry('insert_run.php',$query);

      if(!$result)
      {
         $link=my_redirect('insert.php?error_generic=1');
         $manager->redirect($link);
      }
      else
      {
         $link=my_redirect('insert.php?successful=1');
         $manager->redirect($link);
      }
   }
}

// ADD ROLE
function add_role($manager,$mysqli,$log)
{
   $manager->fetch_variables(array("role"));

   $error_gen=false;

   /*
	if(get_magic_quotes_gpc())
	{
	   $manager->variables["role"]=stripslashes($manager->variables["role"]);
	}
   */

   if(empty($manager->variables["role"]))
   {
      $manager->variables["error_role"]=1;
      $error_gen=true;
   }

   if($error_gen)
   {
      $link=my_redirect('insert.php');
      $link=$manager->compose_link($link,$manager->variables,true);
      $manager->redirect($link);
   }
   else
   {
      // add smth
      $role_sql=$mysqli->real_escape_string($manager->variables["role"]);
      $query=sprintf("INSERT INTO roles(role) VALUES ('%s')",$role_sql);

      $result=$mysqli->query($query);

      $log->add_entry('insert_run.php',$query);

      if(!$result)
      {
         $link=my_redirect('insert.php?error_generic=1');
         $manager->redirect($link);
      }
      else
      {
         $link=my_redirect('insert.php?successful=1');
         $manager->redirect($link);
      }
   }
}

// ADD GENRE
function add_genre($manager,$mysqli,$log)
{
   $manager->fetch_variables(array("genre"));

   $error_gen=false;

   /*
	if(get_magic_quotes_gpc())
	{
	   $manager->variables["genre"]=stripslashes($manager->variables["genre"]);
	}
   */

   if(empty($manager->variables["genre"]))
   {
      $manager->variables["error_genre"]=1;
      $error_gen=true;
   }

   if($error_gen)
   {
      $link=my_redirect('insert.php');
      $link=$manager->compose_link($link,$manager->variables,true);
      $manager->redirect($link);
   }
   else
   {
      // add smth
      $genre_sql=$mysqli->real_escape_string($manager->variables["genre"]);
      $query=sprintf("INSERT INTO genres(genre) VALUES ('%s')",$genre_sql);

      $result=$mysqli->query($query);

      $log->add_entry('insert_run.php',$query);

      if(!$result)
      {
         $link=my_redirect('insert.php?error_generic=1');
         $manager->redirect($link);
      }
      else
      {
         $link=my_redirect('insert.php?successful=1');
         $manager->redirect($link);
      }
   }
}

// ADD NATION
function add_nation($manager,$mysqli,$log)
{
   $manager->fetch_variables(array("nation_name","language_name"));

   $error_gen=false;

   /*
	if(get_magic_quotes_gpc())
	{
	   $manager->variables["nation_name"]=stripslashes($manager->variables["nation_name"]);
	   $manager->variables["language_name"]=stripslashes($manager->variables["language_name"]);
	}
   */

   if(empty($manager->variables["nation_name"]))
   {
      $manager->variables["error_nation_name"]=1;
      $error_gen=true;
   }
   if(empty($manager->variables["language_name"]))
   {
      $manager->variables["error_language_name"]=1;
      $error_gen=true;
   }

   if($error_gen)
   {
      $link=my_redirect('insert.php');
      $link=$manager->compose_link($link,$manager->variables,true);
      $manager->redirect($link);
   }
   else
   {
      // add smth
      $nation_sql=$mysqli->real_escape_string($manager->variables["nation_name"]);
      $language_sql=$mysqli->real_escape_string($manager->variables["language_name"]);
      $query=sprintf("INSERT INTO nations(nation,language) VALUES ('%s','%s')",$nation_sql,$language_sql);

      $result=$mysqli->query($query);

      $log->add_entry('insert_run.php',$query);

      if(!$result)
      {
         $link=my_redirect('insert.php?error_generic=1');
         $manager->redirect($link);
      }
      else
      {
         $link=my_redirect('insert.php?successful=1');
         $manager->redirect($link);
      }
   }
}
?>
