<?php
// last edit: 09-10-2012
// TO use this file instead of the default one change admin_run.php too because the log_file is now log/action_log.bd instead of log/action_log.txt

class my_log_manager
{

	protected $database;
	protected $sqlite;
	protected $disabled=false;

	public function __construct($database="log/action_log.db")
	{
		# set "log/action_log.db"
		$this->database=$database;

		if(file_exists($database))
		{
			# set SQL
			$this->sqlite = new SQLite3($database);
		}
		else
		{
			# create $database file
			trigger_error('(II) Creating database '.$database, E_USER_NOTICE);
			$sqlite = new SQLite3($database);

			$query = 'CREATE TABLE `Log` (`Number` INTEGER PRIMARY KEY, `IP` TEXT NOT NULL, `Action` TEXT NOT NULL, `Query` TEXT NOT NULL, `Date` DATE NOT NULL);';
			$result=$sqlite->exec($query);

			if(!$result)
			{
				# error creating database, disable
				$this->disabled=true;

				# error notice
				trigger_error('(EE) Cannot create database '.$database.'. Action logging disabled', E_USER_NOTICE);

				# set SQL
				$this->sqlite=NULL;
			}
			else
			{
				# set SQL
				$this->disabled=false;
				$this->sqlite=$sqlite;
			}
			
		}
	} // construct

	private function findIP()
	{
		if (!empty($_SERVER['HTTP_CLIENT_IP']))   //check ip from share internet
		{
		  $ip=$_SERVER['HTTP_CLIENT_IP'];
		}
		elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))   //to check ip is pass from proxy
		{
		  $ip=$_SERVER['HTTP_X_FORWARDED_FOR'];
		}
		else
		{
		  $ip=$_SERVER['REMOTE_ADDR'];
		}
		return $ip;

	} // findIP

	public function add_entry($action,$query)
	{
		# adds an entry
		# action = script which ran the query
		# query = query issued

		$ip=$this->findIP();
		$date=date("Y-m-d G:i:s");

		$query_safe=$this->sqlite->escapeString($query);
		$action_safe=$this->sqlite->escapeString($action); // for the day when I will call a script "action','ahah','2012-12-21 00:00:00'); DROP TABLE `Log`; --.php"

		$result=$this->sqlite->exec("INSERT INTO Log(IP,Action,Query,Date) VALUES ('$ip','$action_safe','$query_safe','$date')");

		if(!$result)
		{
			# error notice
			trigger_error('(EE) Cannot insert entry: Action-> '.$action_safe.', Query-> '.$query_safe, E_USER_NOTICE);
		}


	} // add_entry

	public function read_last_queries($number)
	{
		// find the max number of entries (I do not like nested queries)
		$result=$this->sqlite->query("SELECT MAX(Number) FROM Log");
		$row=$result->fetchArray();
		if($row)
		{
			$max_entries=$row[0];
		}
		else
		{
			trigger_error('(EE) Failed query "SELECT MAX(Number) FROM Log". Check action_log.db', E_USER_NOTICE);
			$max_entries=0;
		}

		// find the last $number queries
		$limit=$max_entries-$number;
		$result=$this->sqlite->query("SELECT IP,Action,Query,Date FROM Log WHERE Number>$limit");
		$queries=array();
		while($row=$result->fetchArray())
		{
			$text='('.$row[3].') '.$row[2].'<br><a class="little">'.$row[1].' ['.$row[0].']</a>';
			$queries[]=$text;
		}

		if(empty($queries))
		{
			$queries[0]="No queries in the action_log database";
		}

		return $queries;

	} // read_last_queries

} // my_log_manager
?>
