<?php
// last edit: 09-10-2012

// to output a readable html source file
function my_echo($string)
{
	echo $string."\n";
}

// require the html objects
require("page_manager/html_objects.php");

// my_page_manager
class my_page_manager
{
	public $variables=array();

	public function __construct()
	{
		$variables=array();
	}

	public function ignore_user_abort()
	{
		ignore_user_abort(true);
	}

	public function redirect($location)
	{
		// redirect to the specific location (uses header so you have to use this method before open_page)
		header('Location: '.$location);
	}

	public function open_page($title="My Page",$charset="utf-8")
	{
		// write the W3C Doctype
		my_echo('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">');
		my_echo('<html>');
		// write the page head
		my_echo('<head>');
		// page title
		my_echo('<title>'.$title.'</title>');
		// charset
		my_echo('<meta http-equiv="Content-Type" content="text/html; charset='.$charset.'">');
		// CSS sheet
		my_echo('<link rel="stylesheet" type="text/css" href="page_html/default.css">');
		// end head
		my_echo('</head>');

		// open body
		my_echo('<body>');
	}

	public function close_page()
	{
		// close body
		my_echo('</body>');
		// close HTML
		my_echo('</html>');
	}

	public function write($text,$option="TEXT")
	{
		switch($option)
		{
			case "TEXT":
				$print=htmlspecialchars($text);
				break;
			case "HTML":
				$print=$text;
				break;
			default:
				$print='<a class="'.$option.'">'.htmlspecialchars($text).'</a>';
		}
		my_echo('<p>'.$print.'</p>');
	}

	public function breakline()
	{
		my_echo('<br>');
	}

	public function form($action,$method="GET")
	{
		// create a form
		$form=new my_form($this,$action,$method);

		return $form;
	}

	public function table($columns)
	{
		// create a table
		$table=new my_table($columns);

		return $table;
	}

	public function fetch_variables($variables_names)
	{
		// Find the variables in $_GET and $_POST arrays
		// return an array with the values
		// and save the values in $this->variables

		$return_array=array();
		foreach( $variables_names as $var_name )
		{
			// if the var is set already in $this->variables do nothing
			if( ! isset($this->variables[$var_name]) )
			{
				// search var in $_GET
				if( isset($_GET[$var_name]) )
				{
               $var_real_value=$_GET[$var_name];
               if(get_magic_quotes_gpc())
               {
                  $var_real_value=stripslashes($var_real_value);
               }
					$this->variables[$var_name]=$var_real_value;
					$return_array[$var_name]=$var_real_value;
				}
				else
				{
					// search var in $_POST
					if( isset($_POST[$var_name]) )
					{
                  $var_real_value=$_POST[$var_name];
                  if(get_magic_quotes_gpc())
                  {
                     $var_real_value=stripslashes($_POST[$var_name]);
                  }
						$this->variables[$var_name]=$var_real_value;
						$return_array[$var_name]=$_POST[$var_name];
					}
					else
					{
						// var is NULL
						$this->variables[$var_name]=NULL;
						$return_array[$var_name]=NULL;
					}
				}
			}
			else
			{
				$return_array[$var_name]=$this->variables[$var_name];
			}

		} // foreach

		return $return_array;
	}

	public function fetch_variable($variable)
	{
		// Find a single variable in $_GET and $_POST arrays
		// return the value
		// and save the value in $this->variables

		$arr=array($variable);
		$return=$this->fetch_variables($arr);

		// return
		return $return[$variable];
	}

	public function compose_link($page, $variables=NULL, $redirect=false)
	{
		// I should use this function when dealing with redirects and want to pass some variables with GET,
		// to create a href link simply use return_link_with_get
		// $variables is an hash containing the variables names => values I want to pass to $dest

		if( $variables==NULL )
		{
			$variables=$this->variables;
		}

		$link=$page."?";
		foreach( $variables as $key => $value )
		{
         if($redirect)
         {
		      $link=$link.$key."=".urlencode($value)."&";
         }
         else
         {
		      $link=$link.$key."=".urlencode($value)."&amp;";
         }
		}
      if($redirect)
      {
		   $link=substr($link, 0, -1); // strip last character (? or &)
      }
      else
      {
		   $link=substr($link, 0, -5); // strip last character (? or &)
      }

		// return
		return $link;
	}

	public function return_link($page,$text="Indietro",$text_alt=NULL)
	{
		// A simple return link

		// print link
		if(empty($text_alt))
		{
			my_echo('<p><a href="'.$page.'">'.htmlspecialchars($text).'</a></p>');
		}
		else
		{
			my_echo('<p><a href="'.$page.'">'.htmlspecialchars($text).'</a> '.$text_alt.'</p>');
		}
	}

	public function return_link_with_get($page,$variables=NULL,$text="Indietro",$text_alt=NULL)
	{
		// A return link with the selected variables trasmitted to the target $page using $_GET

		$link=$this->compose_link($page,$variables);

		// write the return link
		$this->return_link($link,$text,$text_alt);
	}
}
// page_manager
?>
