<?php
// last edit: 09-10-2012

// FORM object

class my_form
{

	public $page=NULL;
	protected $action="index.php";
	protected $method="GET";
	public $errors=array();
	public $has_errors=false;

	public function __construct($page,$action,$method="GET")
	{
		$this->page=$page;
		$this->action=$action;
		$this->method=$method;
	}

	public function open()
	{
		// write the form tag
		my_echo('<form method="'.$this->method.'" action="'.$this->action.'">');
	}

	public function close()
	{
		// close form
		my_echo('</form>');
	}

	public function text_input($text,$variable_name,$value=NULL)
	{
		if( $value == NULL )
		{
			// search variable value in the values of the page
			if( isset($this->page->variables[$variable_name]) )
			{
				$value=$this->page->variables[$variable_name];
			}
			else
			{
				$value="";
			}
		}

		// write text and input
		$input=new my_input($this,"text");
		$input->name=$variable_name;
		if( !empty($value))
		{
			$input->value=$value;
		}
		$input->show_with_text($text);

	}

	public function hidden_input($variable_name,$value=NULL)
	{
		// NOTE: Hidden values do not display errors

		if( $value == NULL )
		{
			// search variable value
			if( isset($this->page->variables[$variable_name]) )
			{
				$value=$this->page->variables[$variable_name];
			}
			else
			{
				$value="";
			}
		}

		if( !empty($value) )
		{
			// write text and input
			$input=new my_input($this,"hidden");
			$input->name=$variable_name;
			$input->value=$value;
			$input->show();
		}
		// else error
	}

	public function submit_input($name,$value)
	{
		// submit input

		$input=new my_input($this,"submit");
		$input->name=$name;
		$input->value=$value;
		$input->show();
	}

	public function add_error($variable,$text)
	{
		$this->has_errors=true;

		$this->errors[$variable]=$text;
	}

	public function construct_select_input()
	{
		$select=new my_select_input($this);

		return $select;
	}

}
?>
