<?php
include('lib/my_error_manager.php');
include('lib/my_page_manager.php');
include('lib/my_log_manager.php');
include('mysql_connect.php');

$manager=new my_page_manager();

$log=new my_log_manager();

$all_variables=array("title_like","release_date_after","release_date_before","nation","type","genre","person","role","magic_button");

$manager->fetch_variables($all_variables);

// SEARCH
$show_results=false;
if(!empty($manager->variables["magic_button"]))
{
   $query='SELECT DISTINCT M.id_movie,M.title,M.release_date FROM movies M, movies_people MP, movies_genres MG WHERE 1 ';
   if(!empty($manager->variables["title_like"]))
   {
      $title_sql=$mysqli->real_escape_string($manager->variables["title_like"]);
      $query=$query."AND M.title LIKE '%".$title_sql."%' ";
   }
   if(!empty($manager->variables["release_date_after"]) && preg_match('/^[0-9]{4}-[0-9]{2}-[0-9]{2}+$/',$manager->variables["release_date_after"]) )
   {
      $query=$query."AND '".$manager->variables["release_date_after"]."'<= M.release_date ";
   }
   if(!empty($manager->variables["release_date_before"]) && preg_match('/^[0-9]{4}-[0-9]{2}-[0-9]{2}+$/',$manager->variables["release_date_before"]) )
   {
      $query=$query."AND '".$manager->variables["release_date_before"]."'>= M.release_date ";
   }
   if(!empty($manager->variables["nation"]) && preg_match('/^[0-9]+$/',$manager->variables["nation"]) )
   {
      $query=$query.'AND M.id_nation='.$manager->variables["nation"].' ';
   }
   if(!empty($manager->variables["type"]))
   {
      $type_sql=$mysqli->real_escape_string($manager->variables["type"]);
      $query=$query."AND M.type LIKE '%".$type_sql."%' ";
   }
   if(!empty($manager->variables["genre"]) && preg_match('/^[0-9]+$/',$manager->variables["genre"]) )
   {
      $query=$query.'AND MG.id_genre='.$manager->variables["genre"].' AND MG.id_movie=M.id_movie ';
   }
   if(!empty($manager->variables["person"]) && preg_match('/^[0-9]+$/',$manager->variables["person"]) )
   {
      $query=$query.'AND MP.id_people='.$manager->variables["person"].' AND MP.id_movie=M.id_movie ';
      if(!empty($manager->variables["role"]) && preg_match('/^[0-9]+$/',$manager->variables["role"]) )
      {
         $query=$query.'AND MP.id_role='.$manager->variables["role"];
      }
   }

   $result_search_untouchable=$mysqli->query($query);

   $log->add_entry('search.php',$query);

   $show_results=true;
}

// MISC

// nations list
$query='SELECT id_nation, nation, language FROM nations ORDER BY nation';
$result=$mysqli->query($query);
$nations=array();
$id_nations=array();
while($row=$result->fetch_row())
{
   $id_nations[]=$row[0];
   $nations[]=$row[1].' ('.$row[2].')';
}

// people list
$query='SELECT P.id_people, CONCAT(P.surname , ", ", P.name ) FROM people P ORDER BY P.surname';
$result=$mysqli->query($query);
$people=array();
$id_people=array();
while($row=$result->fetch_row())
{
   $id_people[]=$row[0];
   $people[]=$row[1];
}

// roles list
$query='SELECT R.id_role, R.role FROM roles R ORDER BY R.role';
$result=$mysqli->query($query);
$roles=array();
$id_roles=array();
while($row=$result->fetch_row())
{
   $id_roles[]=$row[0];
   $roles[]=$row[1];
}

// genres list
$query='SELECT G.id_genre, G.genre FROM genres G ORDER BY G.genre';
$result=$mysqli->query($query);
$genres=array();
$id_genres=array();
while($row=$result->fetch_row())
{
   $id_genres[]=$row[0];
   $genres[]=$row[1];
}

// PAGE
$manager->open_page("Search");

$manager->return_link('index.php','HOME');

$form_a=$manager->form('search.php','POST');
$form_a->open();
// title
$form_a->text_input("Title: ","title_like");
// release date
$form_a->text_input("Released (after) [yyyy-mm-dd]: ","release_date_after");
$form_a->text_input("Released (before) [yyyy-mm-dd]: ","release_date_before");
// nation
$select_n=$form_a->construct_select_input();
$select_n->name="nation";
$select_n->add_option('0','Any');
for($i=0;$i<count($nations);$i++)
{
   $select_n->add_option($id_nations[$i],$nations[$i]);
}
$select_n->show_with_text('Nation: ');
// type
$form_a->text_input("Type: ","type");
// genre
$select_g=$form_a->construct_select_input();
$select_g->name="genre";
$select_g->add_option('0','Any');
for($i=0;$i<count($genres);$i++)
{
   $select_g->add_option($id_genres[$i],$genres[$i]);
}
$select_g->show_with_text('Genre: ');
// producer/directos/actor/...
$select_p=$form_a->construct_select_input();
$select_p->name="person";
$select_p->add_option('0','Anyone');
for($i=0;$i<count($people);$i++)
{
   $select_p->add_option($id_people[$i],$people[$i]);
}
$select_p->show_with_text('Starring: ');
// role
$select_r=$form_a->construct_select_input();
$select_r->name="role";
$select_r->add_option('0','Anything');
for($i=0;$i<count($roles);$i++)
{
   $select_r->add_option($id_roles[$i],$roles[$i]);
}
$select_r->show_with_text('in the role of: ');

$form_a->submit_input("magic_button","Search!");

$form_a->close();

// RESULTS
if($show_results)
{
   $manager->breakline();
   $manager->write('RESULTS ('.$result_search_untouchable->num_rows.')',"bold");
   if($result_search_untouchable->num_rows > 0)
   {
      $table=$manager->table(2);
      $table->open();
      while($row=$result_search_untouchable->fetch_row())
      {
         $link=$manager->compose_link("info_movie.php",array("id_movie" => $row[0]));
         $title='<a href="'.$link.'">'.$row[1].'</a>';
         $table->add_row(array($title,$row[2]));
      }
      $table->close();
   }
   else
   {
      $manager->write("No results :-(");
   }
}

$manager->close_page();
?>
